<?php 
//if no tab is set, default to first/options tab
if(empty($_GET['tab'])) {
	$_GET['tab'] = 'options';
} 
?>
<div class="wrap perfmatters-admin">

	<!-- Plugin Admin Page Title -->
	<h2>Perfmatters Settings</h2>

	<!-- Optimization Guide Notice -->
	<div class="notice notice-info">
    	<p><?php _e( 'Check out our <a href="https://woorkup.com/speed-up-wordpress/" title="WordPress Optimization Guide" target="_blank">complete optimization guide</a> for more ways to speed up WordPress.', 'perfmatters' ); ?></p>
    </div>

    <!-- Tab Navigation -->
	<h2 class="nav-tab-wrapper">
		<a href="?page=perfmatters&tab=options" class="nav-tab <?php echo $_GET['tab'] == 'options' || '' ? 'nav-tab-active' : ''; ?>">Options</a>
		<a href="?page=perfmatters&tab=cdn" class="nav-tab <?php echo $_GET['tab'] == 'cdn' ? 'nav-tab-active' : ''; ?>">CDN</a>
		<a href="?page=perfmatters&tab=extras" class="nav-tab <?php echo $_GET['tab'] == 'extras' ? 'nav-tab-active' : ''; ?>">Extras</a>
		<?php if(!is_plugin_active_for_network('perfmatters/perfmatters.php')) { ?>
			<a href="?page=perfmatters&tab=license" class="nav-tab <?php echo $_GET['tab'] == 'license' ? 'nav-tab-active' : ''; ?>">License</a>
		<?php } ?>
		<a href="?page=perfmatters&tab=support" class="nav-tab <?php echo $_GET['tab'] == 'support' ? 'nav-tab-active' : ''; ?>">Support</a>
	</h2>

	<!-- Plugin Options Form -->
	<form method="post" action="options.php">

		<!-- Main Options Tab -->
		<?php if($_GET['tab'] == 'options') { ?>

		    <?php settings_fields( 'perfmatters_options' ); ?>
		    <?php do_settings_sections( 'perfmatters_options' ); ?>
			<?php submit_button(); ?>

		<!-- CDN Tab -->
		<?php } elseif($_GET['tab'] == 'cdn') { ?>

			<?php settings_fields( 'perfmatters_cdn' ); ?>
		    <?php do_settings_sections( 'perfmatters_cdn' ); ?>
			<?php submit_button(); ?>

		<!-- Extras Tab -->
		<?php } elseif($_GET['tab'] == 'extras') { ?>

			<?php settings_fields( 'perfmatters_extras' ); ?>
		    <?php do_settings_sections( 'perfmatters_extras' ); ?>
			<?php submit_button(); ?>

		<!-- License and Activation Tab -->
		<?php } elseif($_GET['tab'] == 'license') { ?>

			<?php require_once('license.php'); ?>

		<!-- Support Tab -->
		<?php } elseif($_GET['tab'] == 'support') { ?>

			<h2>Support</h2>
			<p>For plugin support and documentation, please visit <a href='https://perfmatters.io/' title='perfmatters' target='_blank'>perfmatters.io</a>.</p>

		<?php } ?>
	</form>

	<?php if($_GET['tab'] != 'support' && $_GET['tab'] != 'license') { ?>

		<div id="perfmatters-legend">
			<div id="perfmatters-tooltip-legend">
				<span>?</span>Click on tooltip icons to view full documentation.
			</div>
		</div>

	<?php } ?>

	<script>
		(function ($) {
			$(".perfmatters-tooltip").hover(function(){
			    $(this).closest("tr").find(".perfmatters-tooltip-text-container").show();
			},function(){
			    $(this).closest("tr").find(".perfmatters-tooltip-text-container").hide();
			});
		}(jQuery));
	</script>
	
</div>