<?php
//register settings + options
function perfmatters_settings() {
	if(get_option('perfmatters_options') == false) {	
		add_option('perfmatters_options', apply_filters('perfmatters_default_options', perfmatters_default_options()));
	}

    //Options Primary Section
    add_settings_section('perfmatters_options', 'Options', 'perfmatters_options_callback', 'perfmatters_options');

    //Disable Emojis
    add_settings_field(
    	'disable_emojis', 
    	perfmatters_title('Disable Emojis', 'disable_emojis') . perfmatters_tooltip('https://perfmatters.io/docs/disable-emojis-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
            'id' => 'disable_emojis',
            'tooltip' => 'Removes WordPress Emojis JavaScript file (wp-emoji-release.min.js).'
        )
    );

    //Disable Embeds
    add_settings_field(
    	'disable_embeds', 
    	perfmatters_title('Disable Embeds', 'disable_embeds') . perfmatters_tooltip('https://perfmatters.io/docs/disable-embeds-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'disable_embeds',
    		'tooltip' => 'Removes WordPress Embed JavaScript file (wp-embed.min.js).'    		
    	)
    );

    //Remove Query Strings
    add_settings_field(
    	'remove_query_strings', 
    	perfmatters_title('Remove Query Strings', 'remove_query_strings') . perfmatters_tooltip('https://perfmatters.io/docs/remove-query-strings-from-static-resources/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_query_strings',
    		'tooltip' => 'Remove query strings from static resources (CSS, JS).'
    	)
    );

    //Query String Parameters
    /*add_settings_field(
        'query_string_parameters', 
        perfmatters_title('Additional Parameters', 'query_string_parameters') . perfmatters_tooltip(''), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_options', 
        array(
            'id' => 'query_string_parameters',
            'input' => 'text',
            'placeholder' => 'v,id',
            'tooltip' => ''
        )
    );*/

	//Disable XML-RPC
    add_settings_field(
    	'disable_xmlrpc', 
    	perfmatters_title('Disable XML-RPC', 'disable_xmlrpc') . perfmatters_tooltip('https://perfmatters.io/docs/disable-xml-rpc-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'disable_xmlrpc',
    		'tooltip' => 'Disables WordPress XML-RPC functionality.'
    	)
    );

	//Remove jQuery Migrate
    add_settings_field(
    	'remove_jquery_migrate', 
    	perfmatters_title('Remove jQuery Migrate', 'remove_jquery_migrate') . perfmatters_tooltip('https://perfmatters.io/docs/remove-jquery-migrate-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_jquery_migrate',
    		'tooltip' => 'Removes jQuery Migrate JavaScript file (jquery-migrate.min.js).'
    	)
    );

    //Hide WP Version
    add_settings_field(
    	'hide_wp_version', 
    	perfmatters_title('Hide WP Version', 'hide_wp_version') . perfmatters_tooltip('https://perfmatters.io/docs/remove-wordpress-version-number/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'hide_wp_version',
    		'tooltip' => 'Removes WordPress version meta tag.'
    	)
    );

    //Remove wlmanifest Link
    add_settings_field(
    	'remove_wlwmanifest_link', 
    	perfmatters_title('Remove wlwmanifest Link', 'remove_wlwmanifest_link') . perfmatters_tooltip('https://perfmatters.io/docs/remove-wlwmanifest-link-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options',
        array(
        	'id' => 'remove_wlwmanifest_link',
        	'tooltip' => 'Remove wlwmanifest (Windows Live Writer) link tag.'
        )
    );

    //Remove RSD Link
    add_settings_field(
    	'remove_rsd_link', 
    	perfmatters_title('Remove RSD Link', 'remove_rsd_link') . perfmatters_tooltip('https://perfmatters.io/docs/remove-rsd-link-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_rsd_link',
    		'tooltip' => 'Remove RSD (Real Simple Discovery) link tag.'
    	)
    );

    //Remove Shortlink
    add_settings_field(
    	'remove_shortlink', 
    	perfmatters_title('Remove Shortlink', 'remove_shortlink') . perfmatters_tooltip('https://perfmatters.io/docs/remove-shortlink-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_shortlink',
    		'tooltip' => 'Remove Shortlink link tag.'
    	)
    );

    //Disable RSS Feeds
    add_settings_field(
    	'disable_rss_feeds', 
    	perfmatters_title('Disable RSS Feeds', 'disable_rss_feeds') . perfmatters_tooltip('https://perfmatters.io/docs/disable-rss-feeds-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'disable_rss_feeds',
    		'tooltip' => 'Disable WordPress generated RSS feeds.'
    	)
    );

    //Remove Feed Links
    add_settings_field(
    	'remove_feed_links', 
    	perfmatters_title('Remove RSS Feed Links', 'remove_feed_links') . perfmatters_tooltip('https://perfmatters.io/docs/remove-rss-feed-links-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_feed_links',
    		'tooltip' => 'Disable WordPress generated RSS feed link tags.'
    	)
    );

    //Disable Self Pingbacks
    add_settings_field(
    	'disable_self_pingbacks', 
    	perfmatters_title('Disable Self Pingbacks', 'disable_self_pingbacks') . perfmatters_tooltip('https://perfmatters.io/docs/disable-self-pingbacks-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'disable_self_pingbacks',
    		'tooltip' => 'Disable Self Pingbacks (generated when linking to an article on your own blog).'
    	)
    );

    //Remove REST API Links
    add_settings_field(
    	'remove_rest_api_links', 
    	perfmatters_title('Remove REST API Links', 'remove_rest_api_links') . perfmatters_tooltip('https://perfmatters.io/docs/remove-wordpress-rest-api-links/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'remove_rest_api_links',
    		'tooltip' => 'Removes REST API link tag from the front end and the REST API header link from page requests.'
    	)
    );

    //Disable Dashicons
    add_settings_field(
        'disable_dashicons', 
        perfmatters_title('Disable Dashicons', 'disable_dashicons') . perfmatters_tooltip('https://perfmatters.io/docs/remove-dashicons-wordpress/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_options', 
        array(
            'id' => 'disable_dashicons',
            'tooltip' => 'Disables dashicons on the front end when not logged in.'
        )
    );

    //Disable Google Maps
    add_settings_field(
        'disable_google_maps', 
        perfmatters_title('Disable Google Maps', 'disable_google_maps') . perfmatters_tooltip('https://perfmatters.io/docs/disable-google-maps-api-wordpress/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_options', 
        array(
            'id' => 'disable_google_maps',
            'tooltip' => 'Removes any instances of Google Maps being loaded across your entire site.'
        )
    );

    //Disable Heartbeat
    add_settings_field(
    	'disable_heartbeat', 
    	'<label for=\'disable_heartbeat\'>' . __('Disable Heartbeat', 'perfmatters') . '</label>' . perfmatters_tooltip('https://perfmatters.io/docs/disable-wordpress-heartbeat-api/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'disable_heartbeat',
    		'input' => 'select',
    		'options' => array(
    			'' => 'Default',
    			'disable_everywhere' => 'Disable Everywhere',
    			'allow_posts' => 'Only Allow When Editing Posts/Pages'
    		),
    		'tooltip' => 'Disable WordPress Heartbeat everywhere or in certain areas (used for auto saving and revision tracking).'
    	)
    );

    //Heartbeat Frequency
    add_settings_field(
    	'heartbeat_frequency', 
    	'<label for=\'heartbeat_frequency\'>' . __('Heartbeat Frequency', 'perfmatters') . '</label>' . perfmatters_tooltip('https://perfmatters.io/docs/change-heartbeat-frequency-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'heartbeat_frequency',
    		'input' => 'select',
    		'options' => array(
    			'' => '15 Seconds (Default)',
    			'30' => '30 Seconds',
    			'45' => '45 Seconds',
    			'60' => '60 Seconds'
    		),
    		'tooltip' => 'Controls how often the WordPress Heartbeat API is allowed to run.'
    	)
    );

    //Limit Post Revisions
    add_settings_field(
    	'limit_post_revisions', 
    	'<label for=\'limit_post_revisions\'>' . __('Limit Post Revisions', 'perfmatters') . '</label>' . perfmatters_tooltip('https://perfmatters.io/docs/disable-limit-post-revisions-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'limit_post_revisions',
    		'input' => 'select',
    		'options' => array(
    			'' => 'Default',
    			'false' => 'Disable Post Revisions',
    			'1' => '1',
    			'2' => '2',
    			'3' => '3',
    			'4' => '4',
    			'5' => '5',
    			'10' => '10',
    			'15' => '15',
    			'20' => '20',
    			'25' => '25',
    			'30' => '30'
    		),
    		'tooltip' => 'Limits the maximum amount of revisions that are allowed for posts and pages.'
    	)
    );

    //Autosave Interval
    add_settings_field(
    	'autosave_interval', 
    	'<label for=\'autosave_interval\'>' . __('Autosave Interval', 'perfmatters') . '</label>' . perfmatters_tooltip('https://perfmatters.io/docs/change-autosave-interval-wordpress/'), 
    	'perfmatters_print_input', 
    	'perfmatters_options', 
    	'perfmatters_options', 
    	array(
    		'id' => 'autosave_interval',
    		'input' => 'select',
    		'options' => array(
    			'' => '1 Minute (Default)',
    			'120' => '2 Minutes',
    			'180' => '3 Minutes',
    			'240' => '4 Minutes',
    			'300' => '5 Minutes'
    		),
    		'tooltip' => 'Controls how often WordPress will auto save posts and pages while editing.'
    	)
    );

    //Change Login URL
    add_settings_field(
        'login_url', 
        perfmatters_title('Change Login URL', 'login_url') . perfmatters_tooltip('https://perfmatters.io/docs/change-wordpress-login-url/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_options', 
        array(
            'id' => 'login_url',
            'input' => 'text',
            'placeholder' => 'hideme',
            'tooltip' => 'When set, this will change your WordPress login URL (slug) to the provided string and will block wp-admin and wp-login endpoints from being directly accessed.'
        )
    );

    //WooCommerce Options Section
    add_settings_section('perfmatters_woocommerce', 'WooCommerce', 'perfmatters_woocommerce_callback', 'perfmatters_options');

    //Disable WooCommerce Scripts
    add_settings_field(
        'disable_woocommerce_scripts', 
        perfmatters_title('Disable Scripts', 'disable_woocommerce_scripts') . perfmatters_tooltip('https://perfmatters.io/docs/disable-woocommerce-scripts-and-styles/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_woocommerce', 
        array(
            'id' => 'disable_woocommerce_scripts',
            'tooltip' => 'Disables WooCommerce scripts and styles except on product, cart, and checkout pages.'
        )
    );

    //Disable WooCommerce Cart Fragmentation
    add_settings_field(
        'disable_woocommerce_cart_fragmentation', 
        perfmatters_title('Disable Cart Fragmentation', 'disable_woocommerce_cart_fragmentation') . perfmatters_tooltip('https://perfmatters.io/docs/disable-woocommerce-cart-fragments-ajax/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_woocommerce', 
        array(
            'id' => 'disable_woocommerce_cart_fragmentation',
            'tooltip' => 'Completely disables WooCommerce cart fragmentation script.'
        )
    );

    //Disable WooCommerce Status Meta Box
    add_settings_field(
        'disable_woocommerce_status', 
        perfmatters_title('Disable Status Meta Box', 'disable_woocommerce_status') . perfmatters_tooltip('https://perfmatters.io/docs/disable-woocommerce-status-meta-box/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_woocommerce', 
        array(
            'id' => 'disable_woocommerce_status',
            'tooltip' => 'Disables WooCommerce status meta box from the WP Admin Dashboard.'
        )
    );

    //Disable WooCommerce Widgets
    add_settings_field(
        'disable_woocommerce_widgets', 
        perfmatters_title('Disable Widgets', 'disable_woocommerce_widgets') . perfmatters_tooltip('https://perfmatters.io/docs/disable-woocommerce-widgets/'), 
        'perfmatters_print_input', 
        'perfmatters_options', 
        'perfmatters_woocommerce', 
        array(
            'id' => 'disable_woocommerce_widgets',
            'tooltip' => 'Disables all WooCommerce widgets.'
        )
    );

    register_setting('perfmatters_options', 'perfmatters_options');

    //CDN Option
    if(get_option('perfmatters_cdn') == false) {    
        add_option('perfmatters_cdn', apply_filters('perfmatters_default_cdn', perfmatters_default_cdn()));
    }

    //CDN Section
    add_settings_section('perfmatters_cdn', 'CDN', 'perfmatters_cdn_callback', 'perfmatters_cdn');

    //CDN URL
    add_settings_field(
        'enable_cdn', 
        perfmatters_title('Enable CDN Rewrite', 'enable_cdn') . perfmatters_tooltip('https://perfmatters.io/docs/cdn-rewrite/'), 
        'perfmatters_print_input', 
        'perfmatters_cdn', 
        'perfmatters_cdn', 
        array(
            'id' => 'enable_cdn',
            'option' => 'perfmatters_cdn',
            'tooltip' => 'Enables rewriting of your site URLs with your CDN URLs which can be configured below.'
        )
    );

    //CDN URL
    add_settings_field(
        'cdn_url', 
        perfmatters_title('CDN URL', 'cdn_url') . perfmatters_tooltip('https://perfmatters.io/docs/cdn-url/'), 
        'perfmatters_print_input', 
        'perfmatters_cdn', 
        'perfmatters_cdn', 
        array(
            'id' => 'cdn_url',
            'option' => 'perfmatters_cdn',
            'input' => 'text',
            'placeholder' => 'https://cdn.example.com',
            'tooltip' => 'Enter your CDN URL without the trailing backslash. Example: https://cdn.example.com'
        )
    );

    //CDN Included Directories
    add_settings_field(
        'cdn_directories', 
        perfmatters_title('Included Directories', 'cdn_directories') . perfmatters_tooltip('https://perfmatters.io/docs/cdn-included-directories/'), 
        'perfmatters_print_input', 
        'perfmatters_cdn', 
        'perfmatters_cdn', 
        array(
            'id' => 'cdn_directories',
            'option' => 'perfmatters_cdn',
            'input' => 'text',
            'placeholder' => 'wp-content,wp-includes',
            'tooltip' => 'Enter any directories you would like to be included in CDN rewriting, separated by commas (,). Default: wp-content,wp-includes'
        )
    );

    //CDN Exclusions
    add_settings_field(
        'cdn_exclusions', 
        perfmatters_title('CDN Exclusions', 'cdn_exclusions') . perfmatters_tooltip('https://perfmatters.io/docs/cdn-exclusions/'), 
        'perfmatters_print_input', 
        'perfmatters_cdn', 
        'perfmatters_cdn', 
        array(
            'id' => 'cdn_exclusions',
            'option' => 'perfmatters_cdn',
            'input' => 'text',
            'placeholder' => '.php',
            'tooltip' => 'Enter any directories or file extensions you would like to be excluded from CDN rewriting, separated by commas (,). Default: .php'
        )
    );

    register_setting('perfmatters_cdn', 'perfmatters_cdn');

    if(get_option('perfmatters_extras') == false) {    
        add_option('perfmatters_extras', apply_filters('perfmatters_default_extras', perfmatters_default_extras()));
    }
    add_settings_section('perfmatters_extras', 'Extras', 'perfmatters_extras_callback', 'perfmatters_extras');

    //Script Manager
    add_settings_field(
        'script_manager', 
        perfmatters_title('Script Manager', 'script_manager') . perfmatters_tooltip('https://perfmatters.io/docs/disable-scripts-per-post-page/'), 
        'perfmatters_print_input', 
        'perfmatters_extras', 
        'perfmatters_extras', 
        array(
        	'id' => 'script_manager',
        	'option' => 'perfmatters_extras',
        	'tooltip' => 'Enables the Perfmatters Script Manager, which gives you the ability to disable CSS and JS files on a page by page basis.'
        )
    );

    //DNS Prefetch
    add_settings_field(
        'dns_prefetch', 
        perfmatters_title('DNS Prefetch', 'dns_prefetch') . perfmatters_tooltip('https://perfmatters.io/docs/dns-prefetching/'), 
        'perfmatters_print_dns_prefetch', 
        'perfmatters_extras', 
        'perfmatters_extras', 
        array(
            'id' => 'dns_prefetch',
            'option' => 'perfmatters_extras',
            'tooltip' => 'Resolve domain names before a user clicks. Format: //domain.tld (one per line)'
        )
    );

    //Preconnect
    add_settings_field(
        'preconnect', 
        perfmatters_title('Preconnect', 'preconnect') . perfmatters_tooltip('https://perfmatters.io/docs/preconnect/'), 
        'perfmatters_print_preconnect', 
        'perfmatters_extras', 
        'perfmatters_extras', 
        array(
            'id' => 'preconnect',
            'option' => 'perfmatters_extras',
            'tooltip' => 'Preconnect allows the browser to set up early connections before an HTTP request, eliminating roundtrip latency and saving time for users. Format: scheme://domain.tld (one per line)'
        )
    );

    //Clean Uninstall
    add_settings_field(
        'clean_uninstall', 
        perfmatters_title('Clean Uninstall', 'clean_uninstall') . perfmatters_tooltip('https://perfmatters.io/docs/clean-uninstall/'), 
        'perfmatters_print_input', 
        'perfmatters_extras', 
        'perfmatters_extras', 
        array(
            'id' => 'clean_uninstall',
            'option' => 'perfmatters_extras',
            'tooltip' => 'When enabled, this will cause all Perfmatters options data to be removed from your database when the plugin is uninstalled.'
        )
    );

    //Accessibility Mode
    add_settings_field(
        'accessibility_mode', 
        perfmatters_title('Accessibility Mode', 'accessibility_mode', true), 
        'perfmatters_print_input',
        'perfmatters_extras', 
        'perfmatters_extras', 
        array(
        	'id' => 'accessibility_mode',
        	'input' => 'checkbox',
        	'option' => 'perfmatters_extras',
        	'tooltip' => 'Disable the use of visual UI elements in the plugin settings such as checkbox toggles and hovering tooltips.'
        )
    );

    register_setting('perfmatters_extras', 'perfmatters_extras', 'perfmatters_sanitize_extras');

    //edd license option
	register_setting('perfmatters_edd_license', 'perfmatters_edd_license_key', 'perfmatters_edd_sanitize_license');
}
add_action('admin_init', 'perfmatters_settings');

//options default values
function perfmatters_default_options() {
	$defaults = array(
		'disable_emojis' => "0",
		'disable_embeds' => "0",
		'remove_query_strings' => "0",
        //'query_string_parameters' => "",
		'disable_xmlrpc' => "0",
		'remove_jquery_migrate' => "0",
		'hide_wp_version' => "0",
		'remove_wlwmanifest_link' => "0",
		'remove_rsd_link' => "0",
		'remove_shortlink' => "0",
		'disable_rss_feeds' => "0",
		'remove_feed_links' => "0",
		'disable_self_pingbacks' => "0",
		'remove_rest_api_links' => "0",
        'disable_dashicons' => "0",
        'disable_google_maps' => "0",
		'disable_heartbeat' => "",
		'heartbeat_frequency' => "",
		'limit_post_revisions' => "",
		'autosave_interval' => "",
        'login_url' => "",
        'disable_woocommerce_scripts' => "0",
        'disable_woocommerce_cart_fragmentation' => "0",
        'disable_woocommerce_status' => "0",
        'disable_woocommerce_widgets' => "0"
	);
    perfmatters_network_defaults($defaults, 'perfmatters_options');
	return apply_filters('perfmatters_default_options', $defaults);
}

//cdn default values
function perfmatters_default_cdn() {
    $defaults = array(
        'enable_cdn' => "0",
        'cdn_url' => "0",
        'cdn_directories' => "wp-content,wp-includes",
        'cdn_exclusions' => ".php"
    );
    perfmatters_network_defaults($defaults, 'perfmatters_cdn');
    return apply_filters( 'perfmatters_default_cdn', $defaults );
}

//extras default values
function perfmatters_default_extras() {
    $defaults = array(
        'script_manager' => "0",
        'accessibility_mode' => "0"
    );
    perfmatters_network_defaults($defaults, 'perfmatters_extras');
    return apply_filters( 'perfmatters_default_extras', $defaults );
}

function perfmatters_network_defaults(&$defaults, $option) {
    if(is_multisite() && is_plugin_active_for_network('perfmatters/perfmatters.php')) {
        $perfmatters_network = get_site_option('perfmatters_network');
        if(!empty($perfmatters_network['default'])) {
            $networkDefaultOptions = get_blog_option($perfmatters_network['default'], $option);
            if($option == 'perfmatters_cdn') {
                unset($networkDefaultOptions['cdn_url']);
            }
            if(!empty($networkDefaultOptions)) {
                foreach($networkDefaultOptions as $key => $val) {
                    $defaults[$key] = $val;
                }
            }
        }
    }
}

//main options group callback
function perfmatters_options_callback() {
	echo '<p class="perfmatters-subheading">' . __( 'Select which performance options you would like to enable.', 'perfmatters' ) . '</p>';
}

//woocommerce options group callback
function perfmatters_woocommerce_callback() {
    echo '<p class="perfmatters-subheading">' . __( 'Disable specific elements of WooCommerce.', 'perfmatters' ) . '</p>';
}

//cdn group callback
function perfmatters_cdn_callback() {
    echo '<p class="perfmatters-subheading">' . __( 'CDN options that allow you to rewrite your site URLs with your CDN URLs.', 'perfmatters' ) . '</p>';
}

//extras group callback
function perfmatters_extras_callback() {
    echo '<p class="perfmatters-subheading">' . __( 'Extra options that pertain to Perfmatters plugin functionality.', 'perfmatters' ) . '</p>';
}

//print form inputs
function perfmatters_print_input($args) {
    if(!empty($args['option'])) {
        $option = $args['option'];
        if($args['option'] == 'perfmatters_network') {
            $options = get_site_option($args['option']);
        }
        else {
            $options = get_option($args['option']);
        }
    }
    else {
        $option = 'perfmatters_options';
        $options = get_option('perfmatters_options');
    }
    if(!empty($args['option']) && $args['option'] == 'perfmatters_extras') {
        $extras = $options;
    }
    else {
        $extras = get_option('perfmatters_extras');
    }

    echo "<div style='display: table; width: 100%;'>";
        echo "<div class='perfmatters-input-wrapper'>";

            //Text
            if(!empty($args['input']) && ($args['input'] == 'text' || $args['input'] == 'color')) {
                echo "<input type='text' id='" . $args['id'] . "' name='" . $option . "[" . $args['id'] . "]' value='" . (!empty($options[$args['id']]) ? $options[$args['id']] : '') . "' placeholder='" . (!empty($args['placeholder']) ? $args['placeholder'] : '') . "' />";
            }

            //Select
            elseif(!empty($args['input']) && $args['input'] == 'select') {
                echo "<select id='" . $args['id'] . "' name='" . $option . "[" . $args['id'] . "]'>";
                    foreach($args['options'] as $value => $title) {
                        echo "<option value='" . $value . "' "; 
                        if(!empty($options[$args['id']]) && $options[$args['id']] == $value) {
                            echo "selected";
                        } 
                        echo ">" . $title . "</option>";
                    }
                echo "</select>";
            }

            //Checkbox + Toggle
            else {
                if((empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") && (empty($args['input']) || $args['input'] != 'checkbox')) {
                    echo "<label for='" . $args['id'] . "' class='switch'>";
                }
                    echo "<input type='checkbox' id='" . $args['id'] . "' name='" . $option . "[" . $args['id'] . "]' value='1' style='display: block; margin: 0px;' ";
                    if(!empty($options[$args['id']]) && $options[$args['id']] == "1") {
                        echo "checked";
                    }
                    echo ">";
                if((empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") && (empty($args['input']) || $args['input'] != 'checkbox')) {
                       echo "<div class='slider'></div>";
                   echo "</label>";
                }
            }
            
        echo "</div>";

        if(!empty($args['tooltip'])) {
            if((empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") && $args['id'] != 'accessibility_mode') {
                echo "<div class='perfmatters-tooltip-text-wrapper'>";
                    echo "<div class='perfmatters-tooltip-text-container'>";
                        echo "<div style='display: table; height: 100%; width: 100%;'>";
                            echo "<div style='display: table-cell; vertical-align: middle;'>";
                                echo "<span class='perfmatters-tooltip-text'>" . $args['tooltip'] . "</span>";
                            echo "</div>";
                        echo "</div>";
                    echo "</div>";
                echo "</div>";
            }
            else {
                echo "<p style='font-size: 12px; font-style: italic;'>" . $args['tooltip'] . "</p>";
            }
        }
    echo "</div>";
}

//print checkbox toggle option
function perfmatters_print_toggle($args) {
    if(!empty($args['section'])) {
        $section = $args['section'];
        $options = get_option($args['section']);
    }
    else {
        $section = 'perfmatters_options';
        $options = get_option('perfmatters_options');
    }
    if(!empty($args['section']) && $args['section'] == 'perfmatters_extras') {
        $extras = $options;
    }
    else {
        $extras = get_option('perfmatters_extras');
    }
	//$options = get_option('perfmatters_options');
    //$extras = get_option('perfmatters_extras');
    if((empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") && empty($args['checkbox'])) {
        echo "<label for='" . $args['id'] . "' class='switch' style='font-size: 1px;'>";
            echo $args['label'];
    }
    	echo "<input type='checkbox' id='" . $args['id'] . "' name='" . $section . "[" . $args['id'] . "]' value='1' style='display: block; margin: 0px;' ";
    	if(!empty($options[$args['id']]) && $options[$args['id']] == "1") {
    		echo "checked";
    	}
        echo ">";
    if((empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") && empty($args['checkbox'])) {
	       echo "<div class='slider'></div>";
	   echo "</label>";
    }
}

//print select option
function perfmatters_print_select($args) {
	$options = get_option('perfmatters_options');
	echo "<select id='" . $args['id'] . "' name='perfmatters_options[" . $args['id'] . "]'>";
		foreach($args['options'] as $value => $title) {
			echo "<option value='" . $value . "' "; 
			if($options[$args['id']] == $value) {
				echo "selected";
			} 
			echo ">" . $title . "</option>";
		}
	echo "</select>";
}

//print DNS Prefetch
function perfmatters_print_dns_prefetch($args) {
    $extras = get_option('perfmatters_extras');
     echo "<div style='display: table; width: 100%;'>";
        echo "<div class='perfmatters-input-wrapper'>";
            echo "<textarea id='" . $args['id'] . "' name='perfmatters_extras[" . $args['id'] . "]' placeholder='//example.com'>";
                if(!empty($extras['dns_prefetch'])) {
                    foreach($extras['dns_prefetch'] as $line) {
                        echo $line . "\n";
                    }
                }
            echo "</textarea>";
        echo "</div>";
        if(!empty($args['tooltip'])) {
            if(empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") {
                echo "<div class='perfmatters-tooltip-text-wrapper'>";
                    echo "<div class='perfmatters-tooltip-text-container'>";
                        echo "<div style='display: table; height: 100%; width: 100%;'>";
                            echo "<div style='display: table-cell; vertical-align: top;'>";
                                echo "<span class='perfmatters-tooltip-text'>" . $args['tooltip'] . "</span>";
                            echo "</div>";
                        echo "</div>";
                    echo "</div>";
                echo "</div>";
            }
            else {
                echo "<p style='font-size: 12px; font-style: italic;'>" . $args['tooltip'] . "</p>";
            }
        }
    echo "</div>";
}

//print Preconnect
function perfmatters_print_preconnect($args) {
    $extras = get_option('perfmatters_extras');
     echo "<div style='display: table; width: 100%;'>";
        echo "<div class='perfmatters-input-wrapper'>";
            echo "<textarea id='" . $args['id'] . "' name='perfmatters_extras[" . $args['id'] . "]' placeholder='https://example.com'>";
                if(!empty($extras['preconnect'])) {
                    foreach($extras['preconnect'] as $line) {
                        echo $line . "\n";
                    }
                }
            echo "</textarea>";
        echo "</div>";
        if(!empty($args['tooltip'])) {
            if(empty($extras['accessibility_mode']) || $extras['accessibility_mode'] != "1") {
                echo "<div class='perfmatters-tooltip-text-wrapper'>";
                    echo "<div class='perfmatters-tooltip-text-container'>";
                        echo "<div style='display: table; height: 100%; width: 100%;'>";
                            echo "<div style='display: table-cell; vertical-align: top;'>";
                                echo "<span class='perfmatters-tooltip-text'>" . $args['tooltip'] . "</span>";
                            echo "</div>";
                        echo "</div>";
                    echo "</div>";
                echo "</div>";
            }
            else {
                echo "<p style='font-size: 12px; font-style: italic;'>" . $args['tooltip'] . "</p>";
            }
        }
    echo "</div>";
}

//sanitize extras
function perfmatters_sanitize_extras($values) {
    if(!empty($values['dns_prefetch'])) {
        $text = trim($values['dns_prefetch']);
        $text_array = explode("\n", $text);
        $text_array = array_filter($text_array, 'trim');
        $values['dns_prefetch'] = $text_array;
    }
    if(!empty($values['preconnect'])) {
        $text = trim($values['preconnect']);
        $text_array = explode("\n", $text);
        $text_array = array_filter($text_array, 'trim');
        $values['preconnect'] = $text_array;
    }
    return $values;
}

//sanitize EDD license
function perfmatters_edd_sanitize_license($new) {
	$old = get_option( 'perfmatters_edd_license_key' );
	if($old && $old != $new) {
		delete_option( 'perfmatters_edd_license_status' ); // new license has been entered, so must reactivate
	}
	return $new;
}

//print tooltip
function perfmatters_tooltip($link) {
	$var = "<a ";
        if(!empty($link)) {
            $var.= "href='" . $link . "' title='View Documentation' ";
        }
        $var.= "class='perfmatters-tooltip' target='_blank'>?";
    $var.= "</a>";
    return $var;
}

//print title
function perfmatters_title($title, $id, $checkbox = false) {
    if(!empty($title)) {
        $var = $title;
        if(!empty($id)) {
            $extras = get_option('perfmatters_extras');
            if((!empty($extras['accessibility_mode']) && $extras['accessibility_mode'] == "1") || $checkbox == true) {
                $var = "<label for='" . $id . "'>" . $var . "</label>";
            }
        }
        return $var;
    }
}